SELECT     PC.Name AS Subcategory, DATEPART(yy, SOH.OrderDate) AS [Order Date], 
		   SUM(SOD.LineTotal) AS [Sales Amount], COUNT(SOH.SalesOrderID) AS [Order Count]
FROM       Production.ProductCategory AS PC INNER JOIN
           Production.ProductSubcategory AS PSC ON PC.ProductCategoryID = PSC.ProductCategoryID INNER JOIN
           Production.Product AS P ON PSC.ProductSubcategoryID = P.ProductSubcategoryID INNER JOIN
           Sales.SalesOrderDetail AS SOD ON P.ProductID = SOD.ProductID INNER JOIN
           Sales.SalesOrderHeader AS SOH ON SOD.SalesOrderID = SOH.SalesOrderID AND SOD.SalesOrderID = SOH.SalesOrderID AND 
           SOD.SalesOrderID = SOH.SalesOrderID
GROUP BY PC.Name, DATEPART(yy, SOH.OrderDate)
ORDER BY PC.Name, DATEPART(yy, SOH.OrderDate)