Imports System.Net
Imports System.Xml
Imports System.IO
Imports System.Text
Imports System.Diagnostics
Imports System.Configuration

Public Class Main
    Private m_strURL As String
    Private m_strDSI As String
    Private m_strCatalog As String
    Private m_strUserName As String
    Private m_strPassword As String

    Private Const FILE_IN = "in.xml"
    Private Const FILE_OUT = "out.xml"

    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
        Try
            Me.Cursor = Cursors.WaitCursor
            SendXMLAQuery()
        Catch ex As Exception
            Throw ex
        Finally
            Me.Cursor = Cursors.Default
        End Try
    End Sub
    ''' <summary>
    ''' Sends XMLA query to the server 
    ''' </summary>
    ''' <remarks>Configure the server for HTTP access as explained in 
    '''         http://www.sqlserveranalysisservices.com/OLAPPapers/ConfiguringHTTPAccessToYukon.htm
    ''' </remarks>
    Private Sub SendXMLAQuery()
        ' Load the query 
        Dim xmlDoc As New XmlDocument()
        xmlDoc.Load(Application.StartupPath & "\" & FILE_IN)
        ' Convert the xmla payload to byte array
        Dim data As Byte() = System.Text.ASCIIEncoding.Default.GetBytes(xmlDoc.OuterXml)
        ' Specify the URL to receive the request.
        Dim request As HttpWebRequest = CType(WebRequest.Create("http://localhost/olap/msmdpump.dll"), HttpWebRequest)

        ' Set credentials to use for this request.
        request.Credentials = CredentialCache.DefaultCredentials
        request.Accept = "*/*"
        request.UserAgent = Application.ProductName

        ' Set additional header information 
        request.Headers.Add("Accept-Encoding", "gzip,deflate")
        ' XMLA is a SOAP-based protocol so we need to add a SOAP action header 
        request.Headers.Add("SOAPAction", "urn:schemas-microsoft-com:xml-analysis:Execute")
        request.Method = "POST"
        request.ContentType = "text/xml"
        request.ContentLength = data.Length
        Dim stream As Stream = request.GetRequestStream()

        ' Send the data.
        stream.Write(data, 0, data.Length)
        stream.Close()

        ' Get the response from the server
        Dim response As HttpWebResponse = CType(request.GetResponse(), HttpWebResponse)

        ' Get the stream associated with the response.
        Dim receiveStream As Stream = response.GetResponseStream()

        ' Pipes the stream to a higher level stream reader with the required encoding format. 
        Dim readStream As New StreamReader(receiveStream, Encoding.UTF8)

        ' Read the entire response
        Dim result As String = readStream.ReadToEnd()
        response.Close()
        readStream.Close()

        ' Load the response in Xml Document
        xmlDoc.LoadXml(result)
        xmlDoc.Save(Application.StartupPath & "\" & FILE_OUT)
        ' Show the response in the WebBrowser control
        responseBrowser.Navigate(New Uri(Application.StartupPath & "\" & FILE_OUT))

    End Sub

    Private Sub Main_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        requestBrowser.Navigate(New Uri(Application.StartupPath & "\" & FILE_IN))
    End Sub
End Class
