Imports System
Imports System.IO
Imports System.IO.IsolatedStorage
Imports System.Windows.Forms

    _
'/ <summary>
'/ Summary description for Util.
'/ </summary>
Public Class Util

    Public Sub New()
    End Sub 'New

    '/ <summary>
    '/ Gets the isolated storage stream where the user settings are persisted
    '/ </summary>
    '/ <param name="path">Path to the isolated storage</param>
    '/ <param name="m">File Mode</param>
    '/ <param name="a">File Access</param>
    '/ <param name="s">File Share</param>
    '/ <returns></returns>
    Friend Shared Function GetSettingsStream(ByVal path As String, ByVal m As FileMode, ByVal a As FileAccess, ByVal s As FileShare) As Stream
        Return New IsolatedStorageFileStream(path, m, a, s, IsolatedStorageFile.GetUserStoreForAssembly())
    End Function 'GetSettingsStream


    '/ <summary>
    '/ Simple wrappers on top of Show Message to display errors
    '/ </summary>
    '/ <param name="ex"></param>
    Friend Overloads Shared Sub ShowErrorMessage(ByVal ex As System.Exception)
        ShowErrorMessage([String].Empty, ex)
    End Sub 'ShowErrorMessage

    Friend Overloads Shared Sub ShowErrorMessage(ByVal messageText As String)
        ShowErrorMessage(messageText, Nothing)
    End Sub 'ShowErrorMessage

    Friend Overloads Shared Sub ShowErrorMessage(ByVal messageText As String, ByVal ex As System.Exception)
        messageText += ControlChars.CrLf & ex.ToString()
        MessageBox.Show(messageText, My.Application.ApplicationContext.MainForm.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
    End Sub 'ShowErrorMessage

End Class 'Util 
